#include<stdio.h>
#include<math.h>
int p,k;
int isprime(long j){
  long ii;
	for(ii=2;ii<=sqrt(j);ii++){
  	if(j%ii==0)return 0;
  }
  return 1;
}

long f(long p){
     if(p==1)return 0;
     if(isprime(p)) return 1;
     else {
       long a;
       for(a=2;a<=sqrt(p);a++)

       		if(p%a==0) {
       			long b=p/a;
       			return (f(a)*b)+(a*f(b));
          }
       }
     return 0;
 }

 int main(){
  scanf("%d %d",&p,&k);
  int i;
  for(i=1;i<k;i++){
  	p=f(p);
  }
  printf("%u\n",f(p));

  return 0;
 }
